=== added file 'src/com/goldencode/p2j/persist/IndexDefinition.java'
--- src/com/goldencode/p2j/persist/IndexDefinition.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/persist/IndexDefinition.java	2022-11-04 14:40:16 +0000
@@ -0,0 +1,253 @@
+/*
+** Module   : IndexDefinition.java
+** Abstract : A container for a table index metadata.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 IAS 20221104 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+
+package com.goldencode.p2j.persist;
+
+import static com.goldencode.util.NativeTypeSerializer.*; 
+import java.io.*;
+import java.util.*;
+import java.util.stream.*;
+
+import com.goldencode.p2j.persist.TableMapper.*;
+import com.goldencode.p2j.util.*;
+
+/**
+ * Container for a table index metadata. Used to send the metadata of a
+ * DMO to a remote side, when remote appserver calls are involved.
+ */
+public class IndexDefinition
+implements Externalizable
+{
+   /** The legacy name of this index. */
+   private String legacyName;
+   
+   /**
+    * Determine if the index is a primary index: the one with the "primary" annotation or, if
+    * there is no such one, the first in the definition order.
+    */
+   private boolean effectivePrimary;
+   
+   /** Determine if the index is an unique index. */
+   private boolean unique;
+   
+   /** Determine if the index is a word-index index. */
+   private boolean word;
+   
+   /** Index components (fields with sorting directions). */
+   private List<IndexComponentDefinition> components;
+
+   /**
+    * Default c'tor
+    */
+   public IndexDefinition()
+   {
+      
+   }
+
+   /**
+    * Constructor 
+    * @param lii
+    *        ORM index info
+    *        
+    */
+   public IndexDefinition(LegacyIndexInfo lii)
+   {
+      this.legacyName = lii.getLegacyName();
+      this.effectivePrimary = lii.isEffectivePrimary();
+      this.unique = lii.isUnique();
+      this.word = lii.isWord();
+      this.components = lii.indexComponents().map(lici -> new IndexComponentDefinition(lici)).
+                                              collect(Collectors.toList());
+   }
+   
+   /**
+    * Add index to the <code>TableBuilder</code>
+    * @param tb
+    *        <code>TableBuilder</code> instance.
+    */
+   public void addTo(TempTableBuilder tb)
+   {
+      
+      tb.addNewIndex(new character(legacyName),
+                     new logical(unique),
+                     new logical(effectivePrimary),
+                     new logical(word));
+      components.stream().forEach(
+               c -> tb.addFieldToIndex(legacyName, 
+                                       c.fieldLegacyName, 
+                                       c.effectiveDescending ? "desc" : "asc"));
+   }
+   
+   /**
+    * Read the index definition from the specified input source.
+    * 
+    * @param    in
+    *           The input source from which the index definition will be read.
+    *
+    * @throws   IOException
+    *           In case of I/O errors.
+    *
+    * @throws  ClassNotFoundException
+    *          If the class of property could not be found/loaded.
+    */
+   @Override
+   public void readExternal(ObjectInput in) 
+   throws IOException, 
+          ClassNotFoundException
+   {
+      legacyName = readString(in);
+      byte flags = in.readByte();
+      effectivePrimary = (flags & 1) != 0;
+      unique = (flags & 2) != 0;
+      word = (flags & 4) != 0;
+      components = readList(in, () -> new IndexComponentDefinition());
+   }
+
+   /**
+    * Send the index definition to the specified output destination.
+    * 
+    * @param    out
+    *           The output destination to which the index definition will be sent.
+    *
+    * @throws   IOException
+    *           In case of I/O errors.
+    */
+   @Override
+   public void writeExternal(ObjectOutput out) 
+   throws IOException
+   {
+      writeString(out, legacyName);
+      out.writeByte((effectivePrimary ? 1 : 0) | (unique ? 2 : 0) | (word ? 1 : 0));
+      writeList(out, components);
+   }
+
+   /** A container with an index component information. */
+   public static class IndexComponentDefinition
+   implements Externalizable
+   {
+      /** The legacy name of the field participating in the index. */
+      private String fieldLegacyName;
+      
+      /** Determines if this component has descending sorting. */
+      private boolean effectiveDescending;
+      
+      /**
+       * Default c'tor
+       */
+      public IndexComponentDefinition()
+      {
+         
+      }
+      /**
+       * Constructor
+       * @param lici
+       *        DMO ORM index component info.
+       */
+      public IndexComponentDefinition(LegacyIndexComponentInfo lici)
+      {
+         this.fieldLegacyName = lici.fieldLegacyName;
+         this.effectiveDescending = lici.effectiveDescending;
+      }
+      
+
+      
+      /**
+       * Read the index definition from the specified input source.
+       * 
+       * @param    in
+       *           The input source from which the index component definition will be read.
+       *
+       * @throws   IOException
+       *           In case of I/O errors.
+       *
+       * @throws  ClassNotFoundException
+       *          If the class of property could not be found/loaded.
+       */
+      @Override
+      public void readExternal(ObjectInput in) 
+      throws IOException, 
+             ClassNotFoundException
+      {
+         fieldLegacyName = readString(in);
+         effectiveDescending = in.readByte() != 0;
+      }
+
+      /**
+       * Send the index definition to the specified output destination.
+       * 
+       * @param    out
+       *           The output destination to which the index component definition will be sent.
+       *
+       * @throws   IOException
+       *           In case of I/O errors.
+       */
+      @Override
+      public void writeExternal(ObjectOutput out) 
+               throws IOException
+      {
+         writeString(out, fieldLegacyName);
+         out.writeByte(effectiveDescending ? 1 : 0);
+      }
+   }
+}

=== modified file 'src/com/goldencode/p2j/persist/PropertyDefinition.java'
--- src/com/goldencode/p2j/persist/PropertyDefinition.java	2022-09-09 15:48:28 +0000
+++ src/com/goldencode/p2j/persist/PropertyDefinition.java	2022-11-11 11:51:27 +0000
@@ -17,6 +17,8 @@
 **     SVL 20201030 Added format, label and columnLabel fields.
 **     OM  20201120 Added SCHEMA-MARSHAL implementation.
 **     CA  20220909 Always marshal the schema, otherwise the remote side will not be able to rebuild the table.
+**     IAS 20221029 Added support for missed properties.
+**     IAS 20221102 Re-worked serialization for SCHEMA-MARSHAL == NONE.
 */
 
 /*
@@ -76,6 +78,10 @@
 
 import java.io.*;
 import java.util.*;
+
+import com.goldencode.p2j.persist.orm.*;
+import com.goldencode.p2j.util.*;
+
 import static com.goldencode.p2j.persist.AbstractTempTable.*;
 import static com.goldencode.util.NativeTypeSerializer.*; 
 
@@ -117,7 +123,25 @@
    
    /** The column label of this property. */
    private String columnLabel;
-   
+
+   /** HELP attribute of this field. */
+   private String help;
+   
+   /** INITIAL attribute of this field. */
+   private String initial;
+
+   /** Flag indicating the field should not be included in serialized output. */
+   private boolean serializeHidden;
+   
+   /** Flag indicating the field is case-sensitive. */
+   private boolean caseSensitive;
+
+   /** Node type of field in XML output. */
+   private String xmlNodeType;
+   
+   /** Code page of the CLOB field. */
+   private String codePage;
+
    /**
     * The SCHEMA-MARSHAL level for the parent  temp-table. It is never {@code SM_DEFAULT} when object is to
     * be serialized. Always {@code SM_DEFAULT} for a read object.
@@ -303,7 +327,31 @@
       this.label = label;
       this.columnLabel = columnLabel;
    }
-   
+
+   /**
+    * Create a new property definition.
+    *
+    * @param    prop
+    *           The ORM field <code>Property</code>.
+    */           
+   public PropertyDefinition(Property prop)
+   {
+      this.name = prop.name;
+      verifyType(prop._fwdType);
+      this.type = prop._fwdType;
+      int extent = prop.index > 0 ? 0 : prop.extent;
+      this.extent = extent == 0 ? NO_EXTENT : extent;
+      this.legacyName = prop.legacy;
+      this.format = prop.format;
+      this.label = prop.label;
+      this.columnLabel = prop.columnLabel;
+      this.help = prop.help;
+      this.initial = prop.initial;
+      this.serializeHidden = prop.serializeHidden;
+      this.caseSensitive = prop.caseSensitive;
+      this.xmlNodeType = prop.xmlNodeType;
+      this.codePage = prop.codePage;
+   }
    /**
     * Get the type of this property.
     * 
@@ -385,6 +433,67 @@
    }
 
    /**
+    * Get help text of this property.
+    *
+    * @return help text of this property.
+    */
+   public String getHelp()
+   {
+      return help;
+   }
+
+   /**
+    * Get initial value of this property.
+    *
+    * @return initial value of this property.
+    */
+   public String getInitial()
+   {
+      return initial;
+   }
+
+   /**
+    * Get 'serialize hidden' flag of this property.
+    *
+    * @return 'serialize hidden' flag of this property.
+    */
+   public boolean isSerializeHidden()
+   {
+      return serializeHidden;
+   }
+
+   /**
+    * Get 'case-sensitive' flag of this property.
+    *
+    * @return 'case-sensitive' flag of this property.
+    */
+   public boolean isCaseSensitive()
+   {
+      return caseSensitive;
+   }
+
+   
+   /**
+    * Get XML node type of this property.
+    *
+    * @return XML node type of this property.
+    */
+   public String getXmlNodeType()
+   {
+      return xmlNodeType;
+   }
+
+   /**
+    * Get code page of this property.
+    *
+    * @return code page of this property.
+    */
+   public String getCodePage()
+   {
+      return codePage;
+   }
+
+   /**
     * Send the property definition to the specified output destination.
     * 
     * @param    out
@@ -396,18 +505,29 @@
    public final void writeExternal(ObjectOutput out)
    throws IOException
    {
+      if (schemaMarshalLevel == SM_NONE)
+      {
+         throw new IllegalStateException("Should not be called if schemaMarshalLevel == SM_NONE");
+      }
       boolean full = schemaMarshalLevel == SM_FULL || schemaMarshalLevel == SM_DEFAULT;
-      // we can't omit the schema-related field information, as otherwise the remote side will not be able to
-      // recreate the temp-table.
-      boolean none = false; // schemaMarshalLevel == SM_NONE;
       
-      writeString(out, none ? null : name);
-      writeString(out, (type == null || none) ? null : type.getName());
-      out.writeInt(none ? 0 : extent);
-      writeString(out, none ? null : legacyName);
-      writeString(out, full ? format : null);
-      writeString(out, full ? label : null);
-      writeString(out, full ? columnLabel : null);
+      writeString(out, name);
+      writeString(out, legacyName);
+      writeString(out, type == null ? null : type.getName());
+      out.writeInt(extent);
+      writeString(out, initial);
+      writeString(out, xmlNodeType);
+      writeString(out, codePage);
+      int flags = (serializeHidden ? 1 : 0) | (caseSensitive ? 2 : 0) | (full ? 4 : 0);
+      out.writeByte(flags);
+      if (!full )
+      {
+         return;
+      }
+      writeString(out, format);
+      writeString(out, label);
+      writeString(out, columnLabel);
+      writeString(out, help);
    }
    
    /**
@@ -427,13 +547,25 @@
           ClassNotFoundException
    {
       name = readString(in);
+      legacyName = readString(in);
       String tn = readString(in);
       type = (tn == null) ? null : Class.forName(tn);
       extent = in.readInt();
-      legacyName = readString(in);
+      initial = readString(in);
+      xmlNodeType = readString(in);
+      codePage = readString(in);
+      int flags = in.readByte();
+      serializeHidden = (flags & 1) != 0;
+      caseSensitive = (flags & 2) != 0;
+      boolean full = (flags & 4) != 0;
+      if (!full)
+      {
+         return;
+      }
       format = readString(in);
       label = readString(in);
       columnLabel = readString(in);
+      help = readString(in);
    }
    
    /**

=== modified file 'src/com/goldencode/p2j/persist/TableMapper.java'
--- src/com/goldencode/p2j/persist/TableMapper.java	2022-10-31 12:20:33 +0000
+++ src/com/goldencode/p2j/persist/TableMapper.java	2022-11-11 09:28:43 +0000
@@ -102,7 +102,10 @@
 **     CA  20220601 getIndexFieldNames must return lowercased legacy names.
 **     OM  20220914 Added MAX-WIDTH support for CHARACTER fields.
 **     IAS 20221006 Added 'definedFormat' and 'definedLabel'.
+**     IAS 20221018 Fixed processing of 'now' and 'today' INITIAL attribute value.
 **     CA  20221031 Added JMX instrumentation for 'mapTemporaryTable'.
+**     IAS 20222204 Added 'indexComponents()' and 'getLegacyIndexes' methods.
+**     IAS 20221111 Minor cleanup of the LegacyFieldInfo c'tor.
 */
 
 /*
@@ -163,6 +166,7 @@
 import java.lang.reflect.*;
 import java.util.*;
 import java.util.concurrent.*;
+import java.util.stream.Stream;
 
 import com.goldencode.p2j.persist.annotation.*;
 import com.goldencode.p2j.persist.annotation.Trigger;
@@ -788,6 +792,22 @@
    }
    
    /**
+    * Get stream for the indexes associated with the given temporary table.
+    *
+    * @param    tt
+    *           Temp table object.
+    * @return   stream for the indexes associated with the given temporary table.
+    */
+   public static Stream<TableMapper.LegacyIndexInfo> getLegacyIndexes(TempTable tt)
+   {
+      TempTableMapper mapper = locateTemp(tt);
+      
+      synchronized (mapper)
+      {
+         return mapper.legacyIndexInfo(tt);
+      }
+   }
+   /**
     * Get information about the index associated with the DMO referenced by the given buffer,
     * as a string.
     *
@@ -2663,6 +2683,19 @@
       }
       
       /**
+       * Get stream for the indexes associated with the given temporary table.
+       *
+       * @param    tt
+       *           Temp table object.
+       * @return   stream for the indexes associated with the given temporary table.
+       */
+      private Stream<LegacyIndexInfo> legacyIndexInfo(TempTable tt)
+      {
+         LegacyTableInfo tableInfo = p2j.get(tt);
+         return new ArrayList<>(tableInfo.idx).stream();
+      }
+
+      /**
        * Get the legacy index name of converted index, which is defined by the specified backing
        * temp table.
        *
@@ -2882,7 +2915,7 @@
                   {
                      if ("today".equalsIgnoreCase(text))
                      {
-                        initialValue = date.today();
+                        initialValue = new character(text);
                      }
                      else
                      {
@@ -2893,7 +2926,7 @@
                   {
                      if ("now".equalsIgnoreCase(text))
                      {
-                        initialValue = datetime.now();
+                        initialValue = new character(text);
                      }
                      else if (text.toUpperCase().indexOf('T') > 0)
                      {
@@ -2910,7 +2943,7 @@
                   {
                      if ("now".equalsIgnoreCase(text))
                      {
-                        initialValue = datetimetz.now();
+                        initialValue = new character(text);
                      }
                      else if (text.toUpperCase().indexOf('T') > 0)
                      {
@@ -3118,6 +3151,15 @@
       }
       
       /**
+       * Get a stream for the index components.
+       * 
+       * @return iterator for the index components.
+       */
+      public Stream<LegacyIndexComponentInfo> indexComponents()
+      {
+         return Arrays.stream(components);
+      }
+      /**
        * Returns index information as a string. Format of this string is described in
        * {@link Buffer#indexInformation(int)}
        *
@@ -3216,10 +3258,10 @@
    static class LegacyIndexComponentInfo
    {
       /** The legacy name of the field participating in the index. */
-      private final String fieldLegacyName;
+      public final String fieldLegacyName;
       
       /** Determines if this component has descending sorting. */
-      private final boolean effectiveDescending;
+      public final boolean effectiveDescending;
       
       /**
        * Create a new index component information container, holding field name and sorting
@@ -3546,6 +3588,7 @@
          else
          {
             this.format = defaultFormat;
+            this.definedFormat = null;
          }
          
          this.dataType = dataType;

=== modified file 'src/com/goldencode/p2j/persist/TableWrapper.java'
--- src/com/goldencode/p2j/persist/TableWrapper.java	2022-06-02 12:57:09 +0000
+++ src/com/goldencode/p2j/persist/TableWrapper.java	2022-11-11 12:09:56 +0000
@@ -28,6 +28,10 @@
 **                  (so that relations, schema, etc is done on the server-side).
 **     CA  20220428 Allow null peerDef at setPeerDef.
 **     CA  20220602 Added basic support for transport of object instances over appserver call.
+**     IAS 20221029 Added support for the SCHEMA-MARSHAL attribute.
+**     IAS 20221102 Re-worked (de)serialization.
+**     IAS 20221104 Added structured indexes data.
+**     IAS 20221111 Fixed 'schemaMarshalLevel' support.
 */
 
 /*
@@ -86,11 +90,16 @@
 package com.goldencode.p2j.persist;
 
 import static com.goldencode.util.NativeTypeSerializer.*; 
+import static com.goldencode.p2j.persist.AbstractTempTable.*;
+
 import java.io.*;
 import java.lang.reflect.Array;
 import java.util.*;
+import java.util.stream.*;
 
+import com.goldencode.p2j.oo.lang.*;
 import com.goldencode.p2j.util.*;
+import com.goldencode.util.*;
 
 /**
  * Any {@link TableResultSet} instance will be wrapped in a {@link TableWrapper} instance before
@@ -122,6 +131,12 @@
 
    /** Table name. */
    private String tableName;
+   
+   /** Flag indicating that table schema was received */  
+   boolean receivedSchema = false;
+   
+   /** Table SCHEMA-MARSHAL attribute value encodes as int */ 
+   private int schemaMarshalLevel;
 
    /**
     * Determines if this wrapper wraps data from a TABLE-HANDLE parameter. Necessary because of
@@ -159,6 +174,9 @@
     */
    private String indexes = null;
 
+   /** List of indexes' descriptors */
+   private List<IndexDefinition> indexDefs = null;
+   
    /** Flag indicating if the source is a JSON table. */
    private boolean fromJson = false;
    
@@ -423,6 +441,15 @@
    }
    
    /**
+    * Get List of indexes' descriptors.
+    * @return the List of indexes' descriptors.
+    */
+   public List<IndexDefinition> getIndexDefs()
+   {
+      return indexDefs;
+   }
+
+   /**
     * Get the {@link #xmlns XML namespace}.
     * 
     * @return   See above.
@@ -573,7 +600,8 @@
            "A custom result set must not be specified when calling this method!");
       }
 
-      return new ArrayList<PropertyDefinition>(properties);
+      return properties != null ? new ArrayList<PropertyDefinition>(properties) : 
+                                 Collections.emptyList();
    }
 
    /**
@@ -682,53 +710,60 @@
          return;
       }
 
-      writeString(out, tableName);
-      out.writeByte(tableType);
-      out.writeByte(numIndexes);
-      writeString(out,indexes);
-      writeString(out,xmlns);
-      writeString(out,xmlPrefix);
+      boolean writeSchema = schemaMarshalLevel != SM_NONE;
+      out.writeByte(schemaMarshalLevel);
+      if (writeSchema)
+      {
+         writeString(out, tableName);
+         out.writeByte(tableType);
+         out.writeByte(numIndexes);
+         writeString(out,indexes);
+         writeList(out, indexDefs);
+         writeString(out,xmlns);
+         writeString(out,xmlPrefix);
+      }
 
       // write properties
-      Set<Integer> blobProps = null;
-      Set<Integer> objectProps = null;
+      Set<Integer> blobProps = new HashSet<>();
+      Set<Integer> objectProps = new HashSet<>();
       if (resultSet != null)
       {
          int idx = 0;
          while (resultSet.hasMoreProperties())
          {
             PropertyDefinition property = resultSet.nextProperty();
-            out.writeByte(1);
-            property.writeExternal(out);
+            if (writeSchema)
+            {
+               property.setMarshalLevel(schemaMarshalLevel);
+               out.writeByte(1);
+               property.writeExternal(out);
+            }
 
             if (property.getType() == blob.class)
             {
-               if (blobProps == null)
-               {
-                  blobProps = new HashSet<>();
-               }
                blobProps.add(idx);
             }
             else if (object.class.isAssignableFrom(property.getType()))
             {
-               if (objectProps == null)
-               {
-                  objectProps = new HashSet<>();
-               }
                objectProps.add(idx);
             }
             idx = idx + 1;
          }
       }
-      out.writeByte(0);
-   
+      if (writeSchema)
+      {
+         out.writeByte(0);
+      }
+      writeIntSet(out, blobProps);
+      writeIntSet(out, objectProps);
+
       // write data 
       if (resultSet != null)
       {
          while (resultSet.hasMoreRows())
          {
             Object[] row = resultSet.nextRow();
-            if (blobProps != null)
+            if (!blobProps.isEmpty())
             {
                Object[] row2 = new Object[row.length];
                System.arraycopy(row, 0, row2, 0, row2.length);
@@ -743,7 +778,7 @@
                row = row2;
             }
             
-            if (objectProps != null)
+            if (!objectProps.isEmpty())
             {
                Object[] row2 = new Object[row.length];
                System.arraycopy(row, 0, row2, 0, row2.length);
@@ -751,7 +786,7 @@
                {
                   if (row2[idx] instanceof object)
                   {
-                     row2[idx] = new LegacyObject((object) row2[idx]);
+                     row2[idx] = new LegacyObject((object<?>) row2[idx]);
                   }
                }
                
@@ -781,7 +816,9 @@
     * @throws   IOException
     *           In case of I/O errors.
     * @throws   ClassNotFoundException 
+    *          If the class of property could not be found/loaded.
     */
+   @Override
    public final void readExternal(ObjectInput in)
    throws IOException,
           ClassNotFoundException
@@ -802,47 +839,29 @@
          return;
       }
       
-      tableName = readString(in);
-      tableType = in.readByte();
-
-      numIndexes = in.readByte();
-      indexes = readString(in);
-      xmlns = readString(in);
-      xmlPrefix = readString(in);
-      
-      Set<Integer> blobProps = null;
-      Set<Integer> objectProps = null;
-      int idx = 0;
-      properties = new ArrayList<>();
-      do
+      schemaMarshalLevel = in.readByte(); 
+      receivedSchema =  schemaMarshalLevel != SM_NONE;
+      if (receivedSchema)
       {
-         if (in.readByte() == 0)
-         {
-            break;
-         }
-         PropertyDefinition pd = new PropertyDefinition();
-         pd.readExternal(in);
-         properties.add(pd);
-         
-         if (pd.getType() == blob.class)
-         {
-            if (blobProps == null)
-            {
-               blobProps = new HashSet<>();
-            }
-            blobProps.add(idx);
-         }
-         if (object.class.isAssignableFrom(pd.getType()))
-         {
-            if (objectProps == null)
-            {
-               objectProps = new HashSet<>();
-            }
-            objectProps.add(idx);
-         }
-         idx = idx + 1;
+         tableName = readString(in);
+         tableType = in.readByte();
+         numIndexes = in.readByte();
+         indexes = readString(in);
+         indexDefs = readList(in, () -> new IndexDefinition());
+         xmlns = readString(in);
+         xmlPrefix = readString(in);
+         properties = new ArrayList<>();
+         while (in.readByte() != 0)
+         {
+            PropertyDefinition pd = new PropertyDefinition();
+            pd.readExternal(in);
+            properties.add(pd);
+            
+         }
       }
-      while (true);
+      
+      Set<Integer> blobProps = readIntSet(in);
+      Set<Integer> objectProps = readIntSet(in);
       
       // read data
       rows = new ArrayList<>();
@@ -857,23 +876,13 @@
          
          Object[] row = (Object[]) next;
          rows.add(row);
-         if (blobProps != null)
-         {
-            for (Integer i : blobProps)
-            {
-               row[i] = new blob(((MemoryBuffer) row[i]).getValue());
-            }
-         }
-         if (objectProps != null)
-         {
-            for (Integer i : objectProps)
-            {
-               LegacyObject ref = (LegacyObject) row[i];
-               ObjectVar v = new ObjectVar(ref.getType());
-               v.assign(ref.restore());
-               row[i] = v;
-            }
-         }
+         blobProps.stream().forEach(i -> row[i] = new blob(((MemoryBuffer) row[i]).getValue()));
+         objectProps.stream().forEach(i -> {
+            LegacyObject ref = (LegacyObject) row[i];
+            ObjectVar<? extends _BaseObject_> v = new ObjectVar<>(ref.getType());
+            v.assign(ref.restore());
+            row[i] = v;
+         });
 
          next = in.readObject();
          rowsMeta.add((Object[]) next);
@@ -890,6 +899,16 @@
       }
    }
 
+   /** 
+    * Check that table schema was received.
+    * 
+    * @return <code>true</code> if table schema was received.
+    */
+   public boolean isReceivedSchema() 
+   {
+      return receivedSchema;
+   }
+
    /**
     * Determines if this wrapper wraps data from a TABLE-HANDLE parameter.
     *
@@ -921,6 +940,25 @@
       this.tableHandle = tableHandle;
    }
 
+   /** Get encoded table SCHEMA-MARSHAL attribute value.
+    * 
+    * @return encoded table SCHEMA-MARSHAL attribute value.
+    */
+   public int getSchemaMarshalLevel()
+   {
+      return schemaMarshalLevel;
+   }
+
+   /** Set encoded table SCHEMA-MARSHAL attribute value.
+    * 
+    * @param schemaMarshalLevel 
+    *        encoded table SCHEMA-MARSHAL attribute value.
+    */
+   public void setSchemaMarshalLevel(int schemaMarshalLevel)
+   {
+      this.schemaMarshalLevel = schemaMarshalLevel;
+   }
+
    /**
     * Initialize this wrapper with the info from the given temp-table.
     * 
@@ -933,6 +971,8 @@
       Buffer defBuff = (Buffer) table.defaultBufferHandle().getResource();
       this.indexes = TableMapper.getLegacyIndexInfo(table);
       this.numIndexes = indexes.split("\\.").length; // TODO: "." or "\\." ?
+      this.indexDefs = TableMapper.getLegacyIndexes(table).map(lif -> new IndexDefinition(lif)).
+                                                           collect(Collectors.toList());
       this.xmlns = defBuff.namespaceURI().toStringMessage();
       this.xmlPrefix = defBuff.namespacePrefix().toStringMessage();
    }

